﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Serialization;

namespace Hotel_Extranet_API_Example
{
    class Program
    {
        static void Main(string[] args)
        {
            ExtranetHotelList();
        }

        static void ExtranetHotelList()
        {
            // 1. Parameters (parameters you may specify on the request)

            string User = "InsertUsernameHere";
            string Pass = "InsertPasswordHere";

            string Language = "en";

            int HotelCode = 0; //Test environment hotel id: 125
            int ContractCode = 0; //Test environment contract id: 177

            // 2. Initialization (this code initializes all of the neccesaries nodes and propestier of the HotelAvail request)

            WebServiceJPDM.JP_HotelListRQ ExtranetHotelListRQ = new WebServiceJPDM.JP_HotelListRQ();
            ExtranetHotelListRQ.Version = "1.1";
            ExtranetHotelListRQ.Language = Language;

            // 2.1. Login

            WebServiceJPDM.JP_Login Login = new WebServiceJPDM.JP_Login();
            Login.Email = User;
            Login.Password = Pass;
            ExtranetHotelListRQ.Login = Login;
            
            // 2.2. Optional filters

            if (HotelCode > 0 | ContractCode > 0)
            {
                WebServiceJPDM.ArrayOfJP_HotelListRQHotelHotel[] HotelsArray;
                List<WebServiceJPDM.ArrayOfJP_HotelListRQHotelHotel> HotelsList = new List<WebServiceJPDM.ArrayOfJP_HotelListRQHotelHotel>();
                WebServiceJPDM.ArrayOfJP_HotelListRQHotelHotel Hotel = new WebServiceJPDM.ArrayOfJP_HotelListRQHotelHotel();

                if (HotelCode > 0)
                {
                    Hotel.CodeSpecified = true;
                    Hotel.Code = HotelCode;
                }

                if (ContractCode > 0)
                {

                    WebServiceJPDM.JP_TypeIntCodeAttr[] ContractArray;
                    List<WebServiceJPDM.JP_TypeIntCodeAttr> ContractList = new List<WebServiceJPDM.JP_TypeIntCodeAttr>();
                    WebServiceJPDM.JP_TypeIntCodeAttr Contract = new WebServiceJPDM.JP_TypeIntCodeAttr();

                    Contract.Code = ContractCode;
                    ContractList.Add(Contract);
                    ContractArray = ContractList.ToArray();

                    Hotel.Contracts = ContractArray;
                }

                HotelsList.Add(Hotel);
                HotelsArray = HotelsList.ToArray();
                ExtranetHotelListRQ.Hotels = HotelsArray;
            }

            // 3. Request (here we prepare and send the ExtranetHotelList request)

            WebServiceJPDM.HotelExtranetTransactionsClient serv = new WebServiceJPDM.HotelExtranetTransactionsClient();

            Console.WriteLine(string.Format("- EXTRANETHOTELLIST REQUEST"));
            Console.WriteLine(string.Empty);
            Console.WriteLine(string.Format("Endpoint: {0}", serv.Endpoint.Address));
            Console.WriteLine(string.Format("User: {0}", User));
            Console.WriteLine(string.Format("Pass: {0}", Pass));
            if (HotelCode > 0)
            {
                Console.WriteLine(string.Format("HotelCode: {0}", HotelCode));
            }
            if (ContractCode > 0)
            {
                Console.WriteLine(string.Format("ContractCode: {0}", ContractCode));
            }
            Console.WriteLine(string.Empty);

            WebServiceJPDM.JP_HotelListRS RST = serv.ExtranetHotelList(ExtranetHotelListRQ);

            // 4. Response (here we process the ExtranetHotelList response)

            Console.WriteLine(string.Format("- EXTRANETHOTELLIST RESPONSE"));
            Console.WriteLine(string.Empty);
            if (RST != null && RST.Hotels != null)
            {
                int ContractCount = 0;
                int HotelCount = 0;
                foreach (WebServiceJPDM.ArrayOfJP_HotelListRSHotelHotel item in RST.Hotels)
                {
                    HotelCount += 1;
                    foreach (WebServiceJPDM.ArrayOfJP_HotelListRSHotelContractContract contract in item.Contracts)
                        ContractCount += 1;
                }

                Console.WriteLine(string.Format("OK"));
                Console.WriteLine(string.Format("Hotels: {0}", HotelCount));
                Console.WriteLine(string.Format("Contracts: {0}", ContractCount));
            }
            else if (RST != null && RST.Errors != null)
            {
                Console.WriteLine(string.Format("KO"));
                Console.WriteLine(string.Format("Error: {0}", RST.Errors[0].Code));
            }
            else
            {
                Console.WriteLine(string.Format("KO"));
                Console.WriteLine(string.Format("Error: UNKNOWN ERROR"));
            }

            // 5. XML serialization examples (for when you require for the XML logs any of the requests/reponses)

            string rqXML = serializeXML<WebServiceJPDM.JP_HotelListRQ>(ExtranetHotelListRQ);
            string rsXML = serializeXML<WebServiceJPDM.JP_HotelListRS>(RST);

            Console.ReadLine();
        }

        static string serializeXML<T>(object xmlobject)
        {
            XmlSerializer xsSubmit = new XmlSerializer(typeof(T));
            var subReq = xmlobject;

            using (var sww = new StringWriter())
            {
                using (XmlWriter writer = XmlWriter.Create(sww))
                {
                    xsSubmit.Serialize(writer, subReq);
                    return sww.ToString();
                }
            }
        }
    }
}

